START_MAP = 1

;0,1 - show rendertime on border
DEBUG = 0
DEBUG_GAME = 0
DEBUG_MUSIC = 0

;Tiny Darky Dungeons
;Started: December 6,2021
;Last edit: 6 Junuary 2022
;Game by Denis Grachev


;=========================================

   device ZXSPECTRUM128
   
    org 16384
    incbin "gfx\loading.scr"

    ;page 5
    ;org 49152
    ;incbin "gfx\menu.scr"

;    page 7
;    org 49152
;    incbin "gfx\gameBGHUD.scr"
    

    ;include "include\define.a80"      
   
   page 0
   org 25000   
start:    
    di      
    ld sp,24999 ;set stack
    
    ;call fade_out
    xor a : out (254),a    
    call initPages
    ld a,7 : call setPage
    ld hl,bgHud : ld de,49152 : call DecompressZX0    
    xor a : call setPage    
    ;ld hl,gameBg : ld de,16384 : call zx0
    ld hl, mainInterrupt : call IMON ;enable interupts im2        
    call baseInitMusic
    ei      

    call fade_out   
    call kempstonTest : ei

    call intro
    ;ld hl,storyHud : ld de,16384 : call DecompressZX0
    ;call fade_out   

    ld hl,menuHud : ld de,16384 : call DecompressZX0
    call mainMenu

    ld a,START_MAP : ld (currentMap),a    
    call initLevel
    
    ;call startRender

    jp mainLoop     

currentMap:     db 0

startRender:
        ld hl,drawMap0 : ld (renderProc+1),hl
        ld a,1 : ld (renderState),a
        ret

stopRender:
        ld hl,nullProc : ld (renderProc+1),hl
        xor a : ld (renderState),a
        ret
bgHud:        
        incbin "gfx\gameBGHUD.scr.zx0"
        include "include\sound.a80"    
        include "include\messages.a80"      
        include "include\random.a80"
        include "include\menus.a80"
        include "include\actions.a80"        
        include "include\modeDead.a80"  
        include "include\triggers.a80"       
        include "include\modeRead.a80" 
        include "include\modeWin.a80" 
        include "include\shots.a80"
        include "include\camera.a80"    
        include "include\controls.a80"

         display "pre 32768: ",/d,$   

;right after IM table 
        org #8184

        include "include\structures.a80"
        include "include\game.a80"        
        include "include\fxs.a80"        
        include "include\ints.a80"        
        include "include\pages.a80"          
        include "include\render.a80"                         
        include "include\tiles.a80"
        include "include\heroes.a80"
        include "include\enemies.a80"
        include "include\ai.a80"
        include "include\level.a80"        
        include "include\map.a80"            
        
        include "include\statHud.a80"         
        include "include\postProcess.a80"                         
        include "include\modeMagic.a80"        
        include "include\dzx0_fast.asm"    
        include "include\outro.a80"    

        
initOutro:
        ld hl,doOutro : ld (mainProc+1),hl        
        ;put ret and don't clear render map
        ld a,201 : ld (clearRenderMapFlag),a
        call initMusicOutro
        
        ret
                      

renderState:    db 1

mainLoop:
        halt               
        ld a,(renderState)
        or a : jp nz,mainLoop

                  
         IF DEBUG_GAME
                ld a,6 : out (254),a
          ENDIF  
          ;main game frame four
mainProc: call doGame
               
        xor a : out (254),a     

        jp mainLoop

        display "pre 49152: ",/d,$

levelMap = 49152
objectsMap = 49152+4096
triggersMap = 49152 + 8192
        page 0
        org 49152
        include "include\mainMenu.a80"

;active levelMap
;levelMap:   ;incbin "levels\map01.bin"        
;        block 4096,0
;map that hold objects id-s,heroes,enemies,dark rooms,triggers
;0 - null
;1,2,3 - heroes
;4 - 64 ;32 enemies + rezerv for other enemies

;objectsMap:    ;incbin "levels\map01.obj"
;        block 4096,0
;triggersMap:        block 4096,0 ;0-clear other trigger id
        org 49152+4096*3
        align 256
triggersList:
        block 256,255
        align 256
tilesPriorities:
        incbin "levels\tilesPriorities.bin"
        align 256
tilesColissions:        
        incbin "levels\tilesCollisions.bin"
        align 256
tilesShadows:
        incbin "levels\shadowmap.bin"

;game objects list - reserve 1024
gameObjects: ;incbin "levels\map01-objects.bin"
        block 1024,255
        db 255
;reserved block for objects(!)

;        savebin "p0.bin",start,$-start
        


        db 1,1,1,1
        display "pre 65536: ",/d,$
        

        page 3
        org 49152

        include "include\levels.a80"     

         display "page 3 LEVELS: ",/d,$

;         savebin "p3.bin",49152,$-49152

   
        ;store page for music and sound fx player
        page 1
        org 49152                
    include "sound\PTxPlaySound.asm"    
    block 128,0
step1:
    incbin "sound\sfx\step1.pt3",99        
step2:
    incbin "sound\sfx\step2.pt3",99     
sfxCollect:
    incbin "sound\sfx\collect.pt3",99    
sfxChest:
    incbin "sound\sfx\chest.pt3",99    
sfxSwitch:
    incbin "sound\sfx\switch.pt3",99    
sfxHit:
    incbin "sound\sfx\hit5.pt3",99    
sfxHit2:
    incbin "sound\sfx\hit2.pt3",99    
sfxTrigger:
    incbin "sound\sfx\trigger.pt3",99        
sfxMenuMove:
    incbin "sound\sfx\menuMove.pt3",99    
sfxMenuSelect:
    incbin "sound\sfx\menuSelect.pt3",99        
sfxShow:
    incbin "sound\sfx\show.pt3",99    
sfxMagic:
    incbin "sound\sfx\magic.pt3",99        
sfxNull:
    incbin "sound\sfx\null.pt3",99            

music1: 
        dw m1e-m1s
        ;dw 2198
m1s:        
        incbin "sound\music\music1.pt3.zx0"  
m1e:
music2: 
        dw m2e-m2s
m2s:
        incbin "sound\music\music2.pt3.zx0"          
m2e:
music3: 
        dw m3e-m3s
m3s:
        incbin "sound\music\music3.pt3.zx0"          
m3e:
music4: 
        dw m4e-m4s
m4s:
        incbin "sound\music\music4.pt3.zx0"          
m4e:
        display "page 1 SOUND and PACKED MUSIC: ",/d,$

;        savebin "p1.bin",49152,$-49152

        ;working page for music player
	page 4
	org 49152    
    include "sound\PTxPlay.asm"    
    block 128,0
musicOutro:
        incbin "sound\music\music3.pt3"     
music:
    incbin "sound\music\menu.pt3"     

;deadMusic:
;    incbin "sound\music\dead.pt3"     
;   incbin "sound\music\toosd.pt3"
    
     db 1,1,1,1

    display "page 4 MUSIC: ",/d,$

;    savebin "p4.bin",49152,$-49152
        

	IF (_ERRORS = 0) 		
;			savetap "td128.tap",start
                        savesna "td128.sna",start
;			SHELLEXEC "td128.tap"	
    ENDIF






